













#ifdef CONCURRENT

#define MAIN_REG_MAP	    /* STG world */
#include "rtsdefs.h"

#if 0
#ifdef PAR
#include "Statistics.h"
#endif
#endif















TSO_ITBL();

STGFUN(TSO_entry)
{
    FB_
    fflush(stdout);
    fprintf(stderr, "TSO Entry: panic");
    abort();
    FE_
}








STKO_ITBL();

STGFUN(StkO_entry)
{
    FB_
    fflush(stdout);
    fprintf(stderr, "StkO Entry: panic");
    abort();
    FE_

}

#ifndef PAR

STKO_STATIC_ITBL();

STGFUN(StkO_static_entry)
{
    FB_
    fflush(stdout);
    fprintf(stderr, "StkO_static Entry: panic");
    abort();
    FE_

}

#endif








EXTFUN(EnterNodeCode);

STGFUN(BQ_entry)
{   
    FB_

#if defined(GRAN)
    /* Before overwriting TSO_LINK */
    STGCALL3(void,(),GranSimBlock,CurrentTSO,CurrentProc,Node);	
#endif

    TSO_LINK(CurrentTSO) = (P_) BQ_ENTRIES(Node);
    BQ_ENTRIES(Node) = (W_) CurrentTSO;

    LivenessReg = LIVENESS_R1;
    SaveAllStgRegs();
    TSO_PC1(CurrentTSO) = EnterNodeCode;

    if (DO_QP_PROF) {
    	QP_Event1("GR", CurrentTSO);
    }
#ifdef PAR
    if(RTSflags.ParFlags.granSimStats) {
        /* Note that CURRENT_TIME may perform an unsafe call */
	TIME now = CURRENT_TIME;
        TSO_EXECTIME(CurrentTSO) += now - TSO_BLOCKEDAT(CurrentTSO);
        TSO_BLOCKCOUNT(CurrentTSO)++;
	TSO_QUEUE(CurrentTSO) = Q_BLOCKED;
        TSO_BLOCKEDAT(CurrentTSO) = now;
        DumpGranEvent(GR_BLOCK, CurrentTSO);
    }
#endif
#if defined(GRAN)
    ReSchedule(SAME_THREAD); /* NB: GranSimBlock activated next thread */
#else
    ReSchedule(0);
#endif
    FE_
}

BQ_ITBL();



















#if defined(PAR) || defined(GRAN)

STGFUN(RBH_entry)
{
    FB_

#  if defined(GRAN)
    /* Before overwriting TSO_LINK */
    STGCALL3(void,(),GranSimBlock,CurrentTSO,CurrentProc,Node);	
#  endif

    /* In GranSim and GUM on 2.04 the InfoPtr seems to be invalid when entering
       this routine (exact reason is unknown). This change does the safe 
       thing instead. -- HWL */

    switch (INFO_TYPE(INFO_PTR(Node))) {  /* HWL orig: INFO_TYPE(InfoPtr) */
    case INFO_SPEC_RBH_TYPE:
	TSO_LINK(CurrentTSO) = (P_) SPEC_RBH_BQ(Node);
	SPEC_RBH_BQ(Node) = (W_) CurrentTSO;
	break;
    case INFO_GEN_RBH_TYPE:
	TSO_LINK(CurrentTSO) = (P_) GEN_RBH_BQ(Node);
	GEN_RBH_BQ(Node) = (W_) CurrentTSO;
	break;
    default:
	fflush(stdout);
	fprintf(stderr, "Panic: non-{SPEC,GEN} RBH %#lx (IP %#lx)\n", Node, InfoPtr);
	EXIT(EXIT_FAILURE);
    }

    LivenessReg = LIVENESS_R1;
    SaveAllStgRegs();
    TSO_PC1(CurrentTSO) = EnterNodeCode;

    if (DO_QP_PROF) {
	QP_Event1("GR", CurrentTSO);
    }

#  ifdef PAR
    if(RTSflags.ParFlags.granSimStats) {
        /* Note that CURRENT_TIME may perform an unsafe call */
	TIME now = CURRENT_TIME;
        TSO_EXECTIME(CurrentTSO) += now - TSO_BLOCKEDAT(CurrentTSO);
        TSO_BLOCKCOUNT(CurrentTSO)++;
	TSO_QUEUE(CurrentTSO) = Q_BLOCKED;
        TSO_BLOCKEDAT(CurrentTSO) = now;
        DumpGranEvent(GR_BLOCK, CurrentTSO);
    }
#  endif
#  if defined(GRAN)
    ReSchedule(SAME_THREAD);  /* NB: GranSimBlock activated next thread */
#  else
    ReSchedule(0);
#  endif

    FE_
}

#endif














STGFUN(resumeThread)
{
    FB_

    while(IS_INDIRECTION(INFO_PTR(CurrentTSO))) {
    	CurrentTSO = (P_) IND_CLOSURE_PTR(CurrentTSO);
    }

#ifdef PAR
    if (RTSflags.ParFlags.granSimStats) {
	TSO_QUEUE(CurrentTSO) = Q_RUNNING;
	/* Note that CURRENT_TIME may perform an unsafe call */
        TSO_BLOCKEDAT(CurrentTSO) = CURRENT_TIME;
    }
#endif

    CurrentRegTable = TSO_INTERNAL_PTR(CurrentTSO);

    while(IS_INDIRECTION(INFO_PTR(SAVE_StkO))) {
    	SAVE_StkO = (P_) IND_CLOSURE_PTR(SAVE_StkO);
    }
    RestoreAllStgRegs();

    SET_TASK_ACTIVITY(ST_REDUCING);
    RESTORE_CCC(TSO_CCC(CurrentTSO));
    JMP_(TSO_PC1(CurrentTSO));
    FE_
}











STGFUN(CheckHeapCode)
{
    FB_

    ALLOC_HEAP(TSO_ARG1(CurrentTSO)); /* ticky profiling */
    if ((Hp += TSO_ARG1(CurrentTSO)) > HpLim) {
    	ReallyPerformThreadGC(TSO_ARG1(CurrentTSO), rtsFalse);
    	JMP_(resumeThread);
    }
    SET_TASK_ACTIVITY(ST_REDUCING);
    RESUME_(TSO_PC2(CurrentTSO));
    FE_
}








STGFUN(EnterNodeCode)
{
    FB_
    ENT_VIA_NODE();
    InfoPtr=(D_)(INFO_PTR(Node));
    JMP_(ENTRY_CODE(InfoPtr));
    FE_
}












STGFUN(Continue)
{
    FB_

    SET_TASK_ACTIVITY(ST_REDUCING);
    RESUME_(TSO_PC2(CurrentTSO));
    FE_
}









#ifndef PAR













#define DO_RETURN_TEMPLATE(label, cont)	    	\
    STGFUN(label)   	    	    	    	\
    {				    	    	\
      P_ temp;	    	    	    	    	\
      FB_	    	    	    	    	\
      temp = STKO_LINK(StkOReg);  	    	\
      RetReg = STKO_RETURN(StkOReg);	    	\
      StkOReg = temp;	    	    	    	\
      RestoreStackStgRegs();	    	    	\
      JMP_(cont);		    	    	\
      FE_	    	    	    	    	\
    }

DO_RETURN_TEMPLATE(UnderflowDirectReturn, DIRECT(((P_)RetReg)))
DO_RETURN_TEMPLATE(UnderflowVect0, ((P_)RetReg)[RVREL(0)])
DO_RETURN_TEMPLATE(UnderflowVect1, ((P_)RetReg)[RVREL(1)])
DO_RETURN_TEMPLATE(UnderflowVect2, ((P_)RetReg)[RVREL(2)])
DO_RETURN_TEMPLATE(UnderflowVect3, ((P_)RetReg)[RVREL(3)])
DO_RETURN_TEMPLATE(UnderflowVect4, ((P_)RetReg)[RVREL(4)])

DO_RETURN_TEMPLATE(UnderflowVect5, ((P_)RetReg)[RVREL(5)])
DO_RETURN_TEMPLATE(UnderflowVect6, ((P_)RetReg)[RVREL(6)])
DO_RETURN_TEMPLATE(UnderflowVect7, ((P_)RetReg)[RVREL(7)])

DO_RETURN_TEMPLATE(StackUnderflowEnterNode, EnterNodeCode)

#else /* PAR */













STGFUN(CommonUnderflow)
{
    P_ temp;

    FB_
    temp = STKO_LINK(StkOReg);

    /* fprintf(stderr,"Stk Underflow from: %lx to: %lx size abandoned: %d\n",StkOReg,temp,STKO_CLOSURE_CTS_SIZE(StkOReg)); */

    /* change the guy we are abandoning into something
       that will not be "interesting" on the mutables
       list.  (As long as it is there, it will be
       scavenged in GC, and we cannot guarantee that
       it is still a "sane" StkO object).  (And, besides,
       why continue to keep it [and all it pts to] alive?)
       Will & Phil 95/10
    */
    FREEZE_MUT_HDR(StkOReg, ImMutArrayOfPtrs_info);
    MUTUPLE_CLOSURE_SIZE(StkOReg) = MUTUPLE_VHS;

    StkOReg = temp;
    /* ToDo: Fetch the remote stack object here! */
    RestoreStackStgRegs();
    JMP_(RetReg);
    FE_
}

#define DO_RETURN_TEMPLATE(label, cont)	    	\
    STGFUN(label)   	    	    	    	\
    {				    	    	\
      FB_	    	    	    	    	\
      RetReg = STKO_RETURN(StkOReg);	    	\
      RetReg = (StgRetAddr)(cont);		\
      LivenessReg = INFO_LIVENESS(InfoPtr);	\
      JMP_(CommonUnderflow);	    	    	\
      FE_	    	    	    	    	\
    }

DO_RETURN_TEMPLATE(UnderflowDirectReturn, DIRECT(((P_)RetReg)))
DO_RETURN_TEMPLATE(UnderflowVect0, ((P_)RetReg)[RVREL(0)])
DO_RETURN_TEMPLATE(UnderflowVect1, ((P_)RetReg)[RVREL(1)])
DO_RETURN_TEMPLATE(UnderflowVect2, ((P_)RetReg)[RVREL(2)])
DO_RETURN_TEMPLATE(UnderflowVect3, ((P_)RetReg)[RVREL(3)])
DO_RETURN_TEMPLATE(UnderflowVect4, ((P_)RetReg)[RVREL(4)])
DO_RETURN_TEMPLATE(UnderflowVect5, ((P_)RetReg)[RVREL(5)])
DO_RETURN_TEMPLATE(UnderflowVect6, ((P_)RetReg)[RVREL(6)])
DO_RETURN_TEMPLATE(UnderflowVect7, ((P_)RetReg)[RVREL(7)])

STGFUN(PrimUnderflow)
{
    FB_
    RetReg = STKO_RETURN(StkOReg);
    RetReg = (StgRetAddr)DIRECT(((P_)RetReg));
    LivenessReg = NO_LIVENESS;
    JMP_(CommonUnderflow);
    FE_
}

/* 
 * This one is similar, but isn't part of the return vector.  It's only used
 * when we fall off of a stack chunk and want to enter Node rather than
 * returning through RetReg.  (This occurs during UpdatePAP, when the updatee
 * isn't on the current stack chunk.)  It can't be done with the template,
 * because R2 is dead, and R1 points to a PAP.  Only R1 is live.
 */

#if 0

/* old version of the code */
STGFUN(StackUnderflowEnterNode)
{
    FB_
    RetReg = (StgRetAddr)(EnterNodeCode);
    LivenessReg = LIVENESS_R1;
    JMP_(CommonUnderflow);
    FE_
}

#else

/*
   We've inlined CommonUnderFlow because setting RetReg would zap
   the return vector that the node needs.
   We pick up the RetReg from the STkO header instead.
   KH/HWL 14/2/97
*/

STGFUN(StackUnderflowEnterNode)
{
    P_ temp;
    FB_
    RetReg = STKO_RETURN(StkOReg); /* pick up return code from the StkO hdr
                                      needed because we come from UpdatePAP */
    LivenessReg = LIVENESS_R1;

    temp = STKO_LINK(StkOReg);

    /*? fprintf(stderr,"Stk Underflow from: %lx to: %lx size abandoned: %d\n",StkOReg,temp,STKO_CLOSURE_CTS_SIZE(StkOReg)); ?*/

    /* change the guy we are abandoning into something
       that will not be "interesting" on the mutables
       list.  (As long as it is there, it will be
       scavenged in GC, and we cannot guarantee that
       it is still a "sane" StkO object).  (And, besides,
       why continue to keep it [and all it pts to] alive?)
       Will & Phil 95/10
    */
    FREEZE_MUT_HDR(StkOReg, ImMutArrayOfPtrs_info);
    MUTUPLE_CLOSURE_SIZE(StkOReg) = MUTUPLE_VHS;

    StkOReg = temp;
    /* ToDo: Fetch the remote stack object here! */
    RestoreStackStgRegs();
    JMP_(EnterNodeCode);  /* this will enter a PAP containing the old stkos
			     A and B stacks */
    FE_
}
#endif


#endif /* !PAR */

const W_
vtbl_Underflow[] = {
    /* "MAX_VECTORED_RTN" elements (see GhcConstants.lh) */
    (W_) UnderflowVect0,
    (W_) UnderflowVect1,
    (W_) UnderflowVect2,
    (W_) UnderflowVect3,
    (W_) UnderflowVect4,
    (W_) UnderflowVect5,
    (W_) UnderflowVect6,
    (W_) UnderflowVect7
};

#endif /* CONCURRENT */

